<template>
  <div class="w-[900px] h-[600px] bg-slate-50 rounded-lg p-5">
    <div class="flex justify-between items-center pb-2">
      <span>
        Select image
      </span>
      <button class="btn" @click="selectImage">
        Select
      </button>
    </div>
    <ul
      class="flex flex-col gap-y-5 w-full overflow-scroll h-[500px] no-scrollbar"
    >
      <li
        v-for="(image, index) in IMAGES"
        :key="index"
        class="flex items-start rounded border-[4px]"
        @click="setImage(image)"
        :class="checkIfIsActive(image)? 'bg-green-100 border-blue-400': 'bg-blue-100'"
      >
        <img
          class="bg-rose-100 rounded w-[300px] h-[300px] object-contain p-2"
          :src="getImgSrc(image)"
        />
        <div class="flex flex-col justify-center gap-y-2 p-5 h-full">
          <p v-for='(item, id) in imageFields(image)' :key='id'>
            <span>
              {{ item.title }}:
            </span>
            <span>
              {{ item.value }}
            </span>
          </p>
        </div>
      </li>
    </ul>
  </div>
</template>

<script setup lang="ts">
import { Image } from "@prisma/client";
import { getImgSrc, getTime } from "@/helpers/images";
import { storeToRefs } from "pinia";
import { ImagesStore } from "@/stores/images";
import { useModalStore } from "@/stores/modal";
const { CloseModal } = useModalStore();

const $emit = defineEmits(['selectImage'])

const { IMAGES } = storeToRefs(ImagesStore());

const activeImage  = ref<null| Image>(null)

const checkIfIsActive = (image: Image) => image.id === activeImage.value?.id

const selectImage = () => {
  if(activeImage.value) {
    $emit("selectImage", activeImage.value)
    CloseModal()
  }
}

const setImage = (image: Image) => {
  activeImage.value = image
}

const imageFields = (image:Image ) => {
  return [
    {
      title: "Title",
      value: image.name
    },
    {
      title: "Create At",
      value: getTime(image.createdAt).string
    },
    {
      title: "Is Avatar",
      value: Boolean(image.avatarForProductId)
    },
  ]
}
</script>
